#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Green
#property indicator_color2 Red
#property indicator_color3 Red
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2

//
//
//
//
//

extern int    LsmaPeriod       = 5;
extern int    LsmaPrice        = 0;

extern string note             = "turn on Alert = true; turn off = false";
extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = true;
extern bool   alertsEmail      = false;
extern string soundfile        = "alert2.wav";

//
//
//
//
//

double lsma[];
double lsmaDa[];
double lsmaDb[];
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//
    
int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,lsma); 
   SetIndexBuffer(1,lsmaDa);
   SetIndexBuffer(2,lsmaDb);
   SetIndexBuffer(3,trend);
   
   IndicatorShortName("Lsma (" +LsmaPeriod+ ")");


   return(0);
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//      

int start()
{ 
   int counted_bars=IndicatorCounted();
   int limit,i;


   if(counted_bars < 0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   if (trend[limit]==-1) CleanPoint(limit,lsmaDa,lsmaDb);
      for(i = limit; i >= 0; i--)
      {
         lsma[i]   = 3.0 * iMA(NULL,0,LsmaPeriod,0,MODE_LWMA,LsmaPrice,i) - 2.0 * iMA(NULL,0,LsmaPeriod,0,MODE_SMA,LsmaPrice,i);
         lsmaDa[i] = EMPTY_VALUE;
         lsmaDb[i] = EMPTY_VALUE;
         trend[i]  = trend[i+1];
 
         if (lsma[i] > lsma[i+1]) trend[i]= 1;
         if (lsma[i] < lsma[i+1]) trend[i]=-1;
         if (trend[i] == -1) PlotPoint(i,lsmaDa,lsmaDb,lsma);
      }
      
      if (alertsOn)
      {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;

         //
         //
         //
         //
         //
         
         if (trend[whichBar] != trend[whichBar+1])
         if (trend[whichBar] == 1)
               doAlert("uptrend");
         else  doAlert("downtrend");       
   }
   
   return(0);
}
//+------------------------------------------------------------------+


void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Lsma ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Lsma "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}

//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

